%define	debug_package		%{nil}
%define VirtualEnvironment	%{name}-%{version}
%define VirtualEnvironmentPath  %{_prefix}/local/lib/PythonVirtualEnvironments

%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}^lib.*[.-][0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f].so.*|^libcuda|^libtbb|^libz
%global __requires_exclude_from %{VirtualEnvironmentPath}/%{VirtualEnvironment}/lib*
%global __provides_exclude_from %{VirtualEnvironmentPath}/%{VirtualEnvironment}/lib*

%if 0%{?centos} == 8 || 0%{?rhel} == 8
%global _build_id_links	none
%endif

%if 0%{?amzn}
%define __python                %(echo which python3 | scl enable rh-python38 -)
%endif

Name:		maryam
Version:	2.5.2.post2
Release:	1%{?dist}
Summary:	OWASP Maryam is a modular/optional open source framework based on OSINT and data gathering
Group:		Applications
License:	GPL3
Source1:	%{name}-%{version}.tar.gz
URL:		https://github.com/saeeddhqan/Maryam
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%if 0%{?fedora}
BuildRequires:  python3-devel gcc
Requires:	%{__python3}
%endif

%if 0%{?centos} == 9 || 0%{?rhel} == 9
BuildRequires:  python3.11 python3.11-devel gcc
%define __python3 /usr/bin/python3.11
Requires:	%{__python3}
%endif

%if 0%{?centos} == 8 || 0%{?rhel} == 8
BuildRequires:  python3.11-devel python3.11 gcc
%define __python3 /usr/bin/python3.11
Requires:       %{__python3}
%endif

%if 0%{?amzn}
BuildRequires:  python38 python38-devel
%define __python3 /usr/bin/python3.8 gcc
Requires:       %{__python3}
%endif

%description
OWASP Maryam is a modular/optional open source framework based on OSINT and
data gathering. Maryam is written in Python programming language and it’s
designed to provide a powerful environment to harvest data from open sources
and search engines and collect data quickly and thoroughly.

%prep
%setup -cT
sudo mkdir -p %{VirtualEnvironmentPath}
sudo chown %(id -u):%(id -g) %{VirtualEnvironmentPath}
cd %{VirtualEnvironmentPath}
rm -rf %{VirtualEnvironment}

%{__python3} -m venv %{VirtualEnvironment}
cd %{VirtualEnvironment}
tar zxf %{SOURCE1}

%build
cd %{VirtualEnvironmentPath}/%{VirtualEnvironment}
sh -c "source bin/activate; pip3 install --upgrade pip"
sh -c "source bin/activate; cd Maryam*; pip3 install -r requirements"
sh -c "source bin/activate; cd Maryam*; python3 setup.py build"

%install
export QA_RPATHS=$[ 0x0001|0x0002 ]
cd %{VirtualEnvironmentPath}/%{VirtualEnvironment}
sh -c "source bin/activate; cd Maryam*; python3 setup.py install"
rm -rf Maryam*

%{__mkdir_p} %{buildroot}%{VirtualEnvironmentPath}
cd %{VirtualEnvironmentPath}
rsync -a --sparse %{VirtualEnvironment} %{buildroot}%{VirtualEnvironmentPath}
rm -rf %{buildroot}%{VirtualEnvironmentPath}/%{VirtualEnvironment}/.gitignore

mkdir -p %{buildroot}/%{_bindir}
cat > %{buildroot}/%{_bindir}/maryam << 'EOF'
#!/bin/sh

N=$(basename $0)
MA=%{VirtualEnvironment}
VE=%{VirtualEnvironmentPath}

if [ -d $VE ]; then
        source $VE/$MA/bin/activate
        exec python3 $VE/$MA/bin/$N "$@"
else
        echo $0 cannot be found
        exit 2
fi
EOF

%clean
rm -rf ${RPM_BUILD_ROOT}

%files
%defattr(644,root,root,755)
%attr(0755,root,root)	%{_bindir}/%{name}
%attr(0755,root,root)	%{VirtualEnvironmentPath}/%{VirtualEnvironment}/bin/*
%{VirtualEnvironmentPath}/%{VirtualEnvironment}/dist_metrics.pxd
%{VirtualEnvironmentPath}/%{VirtualEnvironment}/etc
%{VirtualEnvironmentPath}/%{VirtualEnvironment}/lib
%{VirtualEnvironmentPath}/%{VirtualEnvironment}/lib64
%{VirtualEnvironmentPath}/%{VirtualEnvironment}/pyvenv.cfg
%{VirtualEnvironmentPath}/%{VirtualEnvironment}/share
%{VirtualEnvironmentPath}/%{VirtualEnvironment}/include

%changelog
* Sun Aug 06 2023 Lawrence R. Rogers <lrr@cert.org> - 2.5.2.post2-1
* Release 2.5.2.post2-1
	Version 2.5.2.post2-1

* Thu Jun 22 2023 Lawrence R. Rogers <lrr@cert.org> - 2.5.2-1
* Release 2.5.2-1
	Version 2.5.2-1

* Wed Mar 29 2023 Lawrence R. Rogers <lrr@cert.org> - 2.5.1-2
* Release 2.5.1-2
	Version 2.5.1-2

* Mon Nov 14 2022 Lawrence R. Rogers <lrr@cert.org> - 2.5.1-1
* Release 2.5.1-1
	Version 2.5.1

* Wed May 26 2021 Lawrence R. Rogers <lrr@cert.org> 2.2.6.post1-1
* Release 2.2.6.post1-1
	Version 2.2.6.post1
